from fastfood_two.application.abstractions.interactor import Interactor
from fastfood_two.application.contracts.gateways import MenuGateway
from fastfood_two.application.contracts.responses import MenuResponse


class GetAllMenus(Interactor[None, list[MenuResponse]]):
    def __init__(self, gateway: MenuGateway) -> None:
        self._menu_gateway = gateway

    async def __call__(self, request=None) -> list[MenuResponse]:
        menus = await self._menu_gateway.get_all_menus()
        return menus
