from sqlalchemy import text
from sqlalchemy.ext.asyncio import AsyncSession

from fastfood_two.application.contracts.responses import MenuResponse
from fastfood_two.infrastructure.pg_storage.mappers.menu_mapper import entity_to_dto


class MenuGatewayImpl:
    def __init__(self, session: AsyncSession) -> None:
        self._session = session

    async def get_all_menus(self) -> list[MenuResponse]:
        query = text("SELECT * FROM menu;")
        menus = await self._session.execute(query)
        return [entity_to_dto(menu) for menu in menus.scalars().all()]
