from sqlalchemy import ForeignKey
from sqlalchemy.orm import Mapped, mapped_column, relationship

from .base import Base
from .common_attrs import str_25, uuidpk


class Menu(Base):
    __tablename__ = "menu"

    id: Mapped[uuidpk]
    title: Mapped[str_25]
    description: Mapped[str | None]

    parent: Mapped[uuidpk | None] = mapped_column(ForeignKey("menu.id", ondelete="CASCADE"), nullable=True)

    submenus: Mapped[list["Menu"]] = relationship(
        "Menu",
        backref="menu",
        lazy="selectin",
        cascade="all, delete",
    )
