from typing import Annotated

from fastapi import Depends

from fastfood_two.application.contracts.gateways import MenuGateway
from fastfood_two.application.usecases.menu.get_all_menus import GetAllMenus
from fastfood_two.presentation.fastapi_backend.depends.stub import Stub


def get_all_menus_usecase(gateway: Annotated[MenuGateway, Depends(Stub(MenuGateway))]) -> GetAllMenus:
    return GetAllMenus(gateway=gateway)
